using FluentValidation;
using CMSMicroservice.Protobuf.Protos.User;
namespace CMSMicroservice.Protobuf.Validator.User;

public class UpdateUserRequestValidator : AbstractValidator<UpdateUserRequest>
{
    public UpdateUserRequestValidator()
    {
        RuleFor(model => model.Id)
            .NotNull();
        RuleFor(model => model.IsRulesAccepted)
            .NotNull();
        RuleFor(model => model.EmailNotifications)
            .NotNull();
        RuleFor(model => model.SmsNotifications)
            .NotNull();
        RuleFor(model => model.PushNotifications)
            .NotNull();
    }
    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(ValidationContext<UpdateUserRequest>.CreateWithOptions((UpdateUserRequest)model, x => x.IncludeProperties(propertyName)));
        if (result.IsValid)
            return Array.Empty<string>();
        return result.Errors.Select(e => e.ErrorMessage);
    };
}
